#!/usr/bin/env python

#  -  - - - -- -   ---- -- -- --- - ---- ----------
#- Shake Batch Renderer Script

#- Shake Batch Render Script takes a folder (it sits in)
#- looks for the first Shake Script it finds
#- looks for all movies it finds
#- runs the script on all movies and outputs new movies

#- Copyright (C) 2005 fALk Grtner

#- http://www.prototypen.com/blog/falk
#- mailto:falk@prototypen.com

#- This program is free software; you can redistribute it and/or modify  it under the terms of the 
#- GNU General Public License as published by  the Free Software Foundation; either version 2 of //
#- the License, or  (at your option) any later version.


#- This program is distributed in the hope that it will be useful,  but WITHOUT ANY WARRANTY; 
#- without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See 
#- the  GNU General Public License for more details.


#- You should have received a copy of the GNU General Public License  along with this program; if 
#- not, write to the Free Software  Foundation, Inc., 
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# - - --- -- - ----- --- --- -- - -----------------


import string, os, re

# mal den aktuellen pfad ermitteln bevor er wieder wech is wa

currPath = os.path.abspath(os.curdir)


# Verzeichnis nach dem ersten Shakescript durchsuchen

lsShkScripts = os.popen("ls *.shk")

ShkScriptsArray = []
for line in lsShkScripts.read().split('\n'): 
    ShkScriptsArray.append(line)
lsShkScripts.close()

print ShkScriptsArray

# suchen und ersetzen von sFileIn und FileOut im ShakeScript
def sShakeScriptParameterExchange(currMovPath, currMovTimeRange):

    ShkScriptName = ShkScriptsArray[0]
    ShkScriptNameClean = re.sub("[ ]+", "_", ShkScriptName)
    
    ShakeScript = open (ShkScriptName, "r")    # hier kann man den script erweitern um multishakescriptinput(tm) zu machen
    ShakeScriptContent  = ShakeScript.read()
    ShakeScript.close()

    #print ShakeScriptContent
    
    # such hund such nach SFileIn(danachsuchenwir)
    # und ersetze dit ooch gleech

    sFileInPos = re.compile ("(?<=SFileIn\(\").*(?=\")")
    sFileInReplaced = sFileInPos.sub(currMovPath, ShakeScriptContent)

    # denn Fileout

    sFileOutPos = re.compile ("(?<=FileOut\().*(?=\"\,)")
    sFileOutContPos = sFileOutPos.search(sFileInReplaced)
    sFileOutPathPosX =  re.sub ("(?<=\,\s\").*", currMovPath[:-4]+"_"+ShkScriptNameClean[:-4]+".mov", sFileOutContPos.group())
    sFileOutReplaced = re.sub ("(?<=FileOut\().*(?=\"\,)", sFileOutPathPosX, sFileInReplaced)    
    
    # und noch die TimeRange (for the heck of it und um zu zeigen das es auch krzer geht wenn man weiss wie)
    
    sTimeRangeX = re.sub("(?<=SetTimeRange\(\").*(?=\"\))", currMovTimeRange, sFileOutReplaced)
    

    
    newShakeScriptPathName = currPath+"/"+ShkScriptNameClean[:-4]+"_"+currMovPath[(len(currPath)+1):-4]+".shk"
    
    ShakeScriptX = open (newShakeScriptPathName, "w")    # dann speichern wir das auch nochmal ab
    ShakeScriptX.write (sTimeRangeX)
    ShakeScriptX.close()

    
    return newShakeScriptPathName    
    
    

# Verzeichnis nach allen .movs durchsuchen und die in nen Array stecken
lsMovs = os.popen("ls *.mov")

movsArray = []

for line in lsMovs.read().split('\n'): 
    movsArray.append(line)
lsMovs.close()

print movsArray

print len(movsArray)




# Time Range ausm aktuellen Mov holen und abspeichern

def timeRangeFunc(currMovPath):
    cmdLnCmd = "shake " + currMovPath + " -info 2>&1"
    shkInfoCmd = os.popen(cmdLnCmd)
    shkInfo = shkInfoCmd.read()
    shkInfoCmd.close()


    timeRangeCheck = re.search ("(?<=Duration: )\d?\d?\d?\d\-\d?\d?\d?\d", shkInfo)
    timeRange = timeRangeCheck.group(0)

    return timeRange



# fr jedes movie eine schleife die dann auch gleich rendert, danach is alles fertisch 

for currMovName in movsArray:
     if currMovName != "":
         currMovPath = currPath + "/" + currMovName

         print currMovPath
        
         currMovTimeRange = timeRangeFunc(currMovPath)
         
         print currMovTimeRange
         
         ShakeScriptX = sShakeScriptParameterExchange(currMovPath, currMovTimeRange)
         
         print ShakeScriptX
        
         shkExecCmdString = "shake " + "-exec " + ShakeScriptX + " -cpus 2 -v 1>&1"# 2>&1"
         
         print shkExecCmdString
         
         shkExecCmd = os.popen (shkExecCmdString)
         for shkExecCmdExit in  shkExecCmd.readline(): 
            print shkExecCmdExit

         shkExecCmd.close()
         
